/*  smplucas.cpp  by K.Tsuru  */ 
//
// SInteger and SLong sample program
// remake since version 2.30
/*
When
p = 2, 3, 5, 7, 13, 17, 19, 31, 61, 89, 107, 127, 521, 607, 1279, 2203,
 2281, 3217, 4253, 4423, 9689, 9941, 11213, 19937, 21701, 23209, 44497,
 86243, 110503, 132049, 216091, 756839, 859433, 1257787, 1398269, 2976221,
 3021377, 6972593, 13466917, 20996011, 24036583, 25964951, 30402457,
 32582657

p=11213 SLong 9.21  SIntger 59.14(sec) ... very slow
p=44497 SLong 166.259(sec)
SInteger ??

2^p-1 is a prime.
*/
const char* const title ="<<<<< Lucas-Lehmer's prime test program >>>>>";

#include "sn.h"

void LucasTestSI(long p)
{
	SInteger L, M, R, Mp(1);
	long i;
	Timer timer;
	double cpu_time;

	L.FFTUsedTimes(0);
	timer.Start();
	Mp <<= p;
	Mp--;				// Mp = 2^p-1
	L = 4;
	cerr << endl << "Using SInteger arithmetic it is testing " << "2^" << p << " - 1";
	cerr << " is testing a prime or not." << endl;

	for(i = 2; i<p; i++) L = (L*L -2)% Mp;
	cpu_time = timer.Stop();
	cout << endl << "Result : 2^" << p << " - 1 is ";
	if( L == 0.0 ) cout << "a prime." << endl;
	else cout << "not a prime." << endl;

	cout << "Total CPU time " << cpu_time <<" sec." << endl;
	cout << "FFT used times = " << Mp.FFTUsedTimes() << endl;
}
SLong Rem(const SLong& m, const SLong& n) { // m%n
	SLong q = m/n;
	return m-n*q;
}
void LucasTestSL(long p)
{
	SLong L, M, R, Mp(1);
	long i;
	Timer timer;
	double cpu_time;

	L.FFTUsedTimes(0);
	timer.Start();
	Mp <<= p;
	Mp--;				// Mp = 2^p-1
	L = 4;
	cerr << endl << "Using SLong arithmetic it is testing " << "2^" << p << " - 1 =" << endl;
	Mp.SetFormat(10);
	cout << Mp << endl;
	cerr << " is testing a prime or not." << endl;
												//p =9689   19937
//	for(i = 2; i<p; i++) L = Rem((L*L -2), Mp); // 7.75      32.1
	for(i = 2; i<p; i++) L = (L*L -2)% Mp;		// 7.02 sec  28.8
	cpu_time = timer.Stop();
	cout << endl << "Result : 2^" << p << " - 1 is ";
	if( L == 0.0 ) cout << "a prime." << endl;
	else cout << "not a prime." << endl;

	cout << "Total CPU time " << cpu_time <<" sec." << endl;
	cout << "FFT used times = " << Mp.FFTUsedTimes() << endl;
}
int main(){
	long p;
	cerr << title << endl;
	cerr << "To test (2^p - 1) is a prime number or not, input p = ? ";
	p = GetLong();
	LucasTestSL(p);
	LucasTestSI(p);
	Ending();
}
