/*  smpratio.cpp  by K.Tsuru  */
const char* title = "<<<< A sample program of SRational class >>>>>";
#include "sn.h"

void ExpSeriesSpeedTest(int n, long sgn){
	RealSize C;
	uint fig = (uint)Stirling((long)abs(n))/DFIGURES + 10u;
	Timer timer;
	double t;
	SInteger f;
	SRational r, sum;
	int i;
	C.SetEffFig(fig);

	SDouble d, e, den, num;

	e = E();
	cout << e << endl;
	f = 1;
	if(sgn > 0) sum = 2.0;
	else { sum = 0.0;  e = 1.0/e; }
	cerr << "Now calculating 1/0! + 1/1! + 1/2! + .... 1/" << n << "! in fraction." << endl;
	timer.Start();
	for(i = 2; i <= n; i++){
		f *= i;
		r.Set((SInteger)1.0, f);
		if( (sgn > 0) || !(i % 2)) sum = sum+r;
		else sum = sum-r;
	}
	sum.Reduce();
	t = timer.Stop();
	cout << "In fraction." << endl;
	sum.Puts();
	Wait();

	puts("In decimal.");
	d = sum.ConvToDec();	// SRational --> SFraction --> SDouble conversion
	d.Puts();
	Wait();

	if(sgn > 0) puts("E() =");
	else puts("1/E() =");
	e.Puts();
	printf(" %ld figures agrees.\n", AgreeUpTo(d, e));
	e = d -e;
	if(sgn > 0) puts("Diffrence E().");
	else puts("Diffrence 1/E().");
	e.Puts();
	printf("CPU time = %.3f\n", t);
	Wait();
	C.SetEffFig(0);
}
void ExpSeriesByRational(){
	int upto;
	ErrorPuts("To caluculate 1/0! + 1/1! + 1/2! + .... 1/n! or");
	ErrorPuts("1/0! - 1/1! + 1/2! - .... 1/n! in fraction,");
	while(1){
		ErrorPut(" n = ?(when n <= 0, quit) ");
		upto = GetInt();
		if(upto <= 0) break;
		ExpSeriesSpeedTest(upto, 1);
		ExpSeriesSpeedTest(upto, -1);
	}
}
void test3(){
	SRational f;
	SLong L, M, N;
	char den[] = "98802 88843 41918 88553 74605 18912";
	char num[] = "72 05759 40368 79360";

	L = den;	M = num;
	N = gcdL(L, M);
	printf("GCD of %s and %s is\n", den, num);
	N.Puts();
	printf("In radix = %hu reduceed value of (%s/%s) is\n",DRADIX, den, num);
	f.Set(L, M);
	f.Puts();
	Wait();
}
void test2(){
// by Moriguti
	SRational f, g, r;
	f = "1009/99799811";	g = "997/99819757";	// set by string in decimal
	r = f+g;	f.Put(0);		putchar('+');   g.Put(0);	putchar('=');	r.Puts(100);
	r = f-g;	f.Put(0);		putchar('-');   g.Put(0);	putchar('=');	r.Puts(100);
	r = f*g;	f.Put(0);		putchar('*');   g.Put(0);	putchar('=');	r.Puts(100);
	r = f/g;	f.Put(0);		putchar('/');   g.Put(0);	putchar('=');	r.Puts(100);
	Wait();
}
void test1(){
	SRational a(1, 300), b(1, 400), c;
	c=a+b;   a.Put();	putchar('+');	b.Put();	putchar('=');	c.Puts();
	c=a-b;   a.Put();	putchar('-');	b.Put();	putchar('=');	c.Puts();
	c=a*b;   a.Put();	putchar('*');	b.Put();	putchar('=');	c.Puts();
	c=a/b;   a.Put();	putchar('/');	b.Put();	putchar('=');	c.Puts();
	Wait();
}
int main(){
	ErrorPuts(title);
	test1();
	test2();
	test3();
	ExpSeriesByRational();
	Ending();
	return EXIT_SUCCESS;
}
