/*  ceilpow2.cpp  by K.Tsuru  */
// function ID = 001
/*********************************************************************************
SN library sub-function
Return a value k which satisfies a condition  sz<=k (k = 2^n).
If sz*2 > UINT_MAX=4294967295(32 bits system),
 return a value INT_MAX+1 = 2147483648L = 2^31.
**********************************************************************************/
#include <limits.h>

unsigned int ceilpow2(unsigned int sz){
	if(sz < 2u) return 1u;
	if(sz > UINT_MAX/2u) return (unsigned int)INT_MAX+1u;

	unsigned int k = 2u;

	while(k < sz) k *= 2u;
	return k;
}
