/*  factfigs.cpp  by K.Tsuru  */
/************************************
It returns the figures of factorial n! in a decimal system
 by the Stirling's formula.
*************************************/
#include <cmath>
#ifndef DEF_CONST_H
#include "defconst.h"
#endif
unsigned long Stirling(unsigned long n){	// ver. 2.17.1 change into "unsigned long"
	static double C1 = 0.5*log10(2*M_PI) +1.0, C2 = log10(M_E);
	if(n < 4) return 1; 	// <= 3! = 6
	double N = n, f = C1 - C2*N + (N + 0.5)*log10(N);
	return (unsigned long)f;
}
