/*  scfcabsH.cpp by K.Tsuru  */
// function ID = 9001
/***************************************
SN library
SComplex class reference
It returns the absolute value of z in high precision version.
****************************************/
#ifndef SN_H
#include "sn.h"
#endif
SDouble CabsH(const SComplex& z){
// z = x + iy
	SDouble x( z.Real() ), y( z.Imag() ), r;
// It takes absolute values.
	if(x.Sign()<0) x.ChangeSign();
	if(y.Sign()<0) y.ChangeSign();
// z = x+i*y
	if(x.Sign() == 0) return y;	// |y|
	if(y.Sign() == 0) return x;	// |x|

// |z| = sqrt(x*x+y*y) = |x|*sqrt(1+(y/x)^2) for |x| > |y|
	if(x > y){ // |x|>|y|
		r = y/x;
		r = 1.0 + r*r;
		r = x*Sqrt(r);
	} else {  // |x|<=|y|
		r = x/y;
		r = 1.0 + r*r;
		r = y*Sqrt(r);
	}
	return r;
}
