/*  scfcpown.cpp  by K.Tsuru  */
// function ID = 9103
/********************************
SComplex class
It returns z^n.
*********************************/
#ifndef SN_H
#include "sn.h"
#endif
SComplex Cpow(const SComplex& z, int n){
	SComplex y(1.0), r;
	if( z.IsZero(9103) ){// 0^n
		SNManager::SetError(SNManager::DOMAIN_ERR, "Cpow z=0", 9103);
	}
	if(n == 0) return y;	// 1.0

	if(n < 0){
		r = y/z;	// y = 1, "1/z" is an error.
		n = -n;
	}else r = z;

	while(1){
		if(n % 2) y *= r;
		n /= 2;
		if( !n ) break;
		r *= r;
	}
	return y;
}
