/*  sdfdpowd.cpp  by K.Tsuru  */
// function ID 3003		DRADIX
/*******************************
SDouble class x^p
It returns x raised to the p power.
 x^p = exp(p*log(x)) for x > 0
*******************************/
#ifndef SN_H
#include "sn.h"
#endif
SDouble DpowD(const SDouble& x, const SDouble& p){
	if(x.Sign(3003) <= 0) x.SetError(x.DOMAIN_ERR,"DpowD", 3003);

	SDouble a;
	a = p*Log(x);
	return Exp(a);
}
