/*  sfffsmul.cpp  by K.Tsuru  */
// function ID = 714  DRADIX
/*************************************
SFraction class
It multiplies "x" by a short value "n".
***************************************/
#ifndef SN_H
#include "sn.h"
#endif

SFraction FsMult(const SFraction& x, ulong n){
	if(n == 1UL) return x;
	if(!n) return 0.0;

	SFraction r(x);
	if(n <= r.num.SlOpMaxValue()) r.num = LsMult(r.num, n);
	else						  r.num *= n;
	r.reduceDone = false;
#if REDUCE_SIZE != 0
	r.reduce(false);
#else
	r.reduce();
#endif
	return r;
}
