/*  sfoequal.cpp  by K.Tsuru  */
// function ID = 7003	DRADIX
/**************************************
SFraction class
It provides the relation operator ==().
**************************************/
#ifndef SN_H
#include "sn.h"
#endif
bool operator==(const SFraction& m, const SFraction& n){
	if(m.Sign(7003) != n.Sign(7003)) return 0;
	if(m.ReduceDone() && n.ReduceDone()){	//Both are irreducible fractions.
		if(LLCompare(m.NumNR(), n.NumNR())) return 0;	//different numerator
		if(LLCompare(m.DenNR(), n.DenNR())) return 0;   //different denominator
		return 1;
	}
	SFraction t;
	if( FFCompare(m, n) ) return 0;
	return 1;
}
