/*  simshift.cpp  by K.Tsuru  */
// function ID = 410	BRADIX
/**********************************************
SInteger class
It provides a bit shift i.e. multiplies by 2^p.
Both cases p>0 and p<0 are allowed.
example : 2^1000
	SLong L;
	SInteger d(1);
	d.BitShift(1000L);
	L = d.ConvToDec();
***********************************************/
#ifndef SN_H
#include "sn.h"
#endif
SInteger& SInteger::BitShift(long p){
	if(!p || !Sign(413)) return *this;
	long n = p/(long)BRADIX_BITS, r = p-(long)BRADIX_BITS*n;
	if(r < 0){
		r += BRADIX_BITS;	n--;
	}
	ulong mul = 1uL << (int)r;

	if(r) IsMult(*this, mul, *this);
//When n < 0 and it becomes zero, "SetZero()" is executed in the function "ShiftArray()".
	ShiftArray((int)n);
	return *this;
}
