/*  sninfo.cpp  by K.Tsuru  */
// function ID = 010
/******************************
Provides SNumber informations.
This is not a member function.
Remade iostream version since version 2.30
*******************************/
#ifndef SN_H
#include "sn.h"
#endif

void FFTInfo(ostream& os){ // default os = cout
	SLong sl;
	SInteger si;
	os << "<<< FFT information >>>" << endl;
	os << "defaultFFTMinSize = " << defaultFFTMinSize << endl;
	os << "fftMaxSize = " << sl.FFTMaxArraySize() << "(DRADIX) and " << si.FFTMaxArraySize() << "(BRADIX)" << endl;
	os << "MFFTMinSize() = " << SNManager::MFFTMinSize();
	os << ",  FFTUsedTimes() = " << SNManager::FFTUsedTimes() << endl;
	string on_off = SNManager::FFTVerify() ?  "ON." : "OFF.";
	os << "FFTVerify is " << on_off << endl;
	os << "FFTWorkSize is " << FFTWorkSize() << "." << endl;
	os << "FFT used memory is " << FFTWorkSize()*sizeof(fftType) << "(bytes)." << endl;
	string yes_no = UsesFFTSineTable ? "Yes" : "No";
	os << "Uses FFTSineTable : " << yes_no << endl;
	yes_no = sl.UsesKaratsubaMult() ? "Yes" : "No";
	os << "Uses Karatsuba's multiplication : " << yes_no << endl;
	os << "Karatsuba's multiplication used times = " << SNManager::KHHMultUsedTimes() << "." << endl;
	yes_no = Uses_long_double_FFT ?  "Yes" : "No";
	os << "Uses \"long double\" in FFT : " << yes_no << endl;
}
void SNInfo(ostream& os){
	SNManager::Version();
	os << "<<< SNumber information >>>" << endl;
	os << "Your compiler  is " << SystemBit() << " bit." << endl;
	os << "SNObjects() = " << SNManager::SNObjects() << endl;
	os << "radix = "<< DRADIX << " / " << BRADIX << endl;
	string on_off = SNManager::Verify() ?  "ON." : "OFF.";
	os << "Verify is " << on_off << endl;
	os << "------- Size information ------------" << endl;
	os << "maxSizeOfMemoryBlock = " << maxSizeOfMemoryBlock << "(bytes), ";
	os << "maxArraySize = " << SNManager::MaxArraySize();
	os << ", minArraySize = " << minArraySize << endl;
	os << "defaultEffFig = " << defaultEffFig << endl;

	os << "----- Real number information -----" << endl;
	os << "EffFigures() = " << SNManager::EffFigures();
	os << ", Hidden() = " << SNManager::Hidden() << endl;
	os << "Maximum size of SDecimal = " << SNManager::SNMaxSize(SNManager::BIN_DEC) << endl;
	os << "Maximum value of exponent = " << DRADIX_EXP_MAX << "(radix = " << DRADIX << ")" << endl<< endl;
	FFTInfo();
}

