/*  snmvaloc.cpp  by K.Tsuru  */
// function ID = 101
/***********************************
SNumber class
It allocates the memory of figure[].
See "snum.h" for details.
************************************/
#ifndef SN_H
#include "sn.h"
#endif
uint SNumber::valloc(uint sz, int copy){
	sz = max(sz, minArraySize);		//It does not free the memory.
	uint max_sz = SNMaxSize(type);
	uint alcsz = (CutDown() == DISABLE) ? max(sz, figure.size()) : sz;

	if(alcsz > max_sz){
		if(type & REAL) alcsz = max_sz;	//real number type(SDouble or SDecimal)
		else if(alcsz > MaxArraySize()) SetError(OVERFLOW_ERR, "valloc", 101);//integer
	}

#ifndef NDEBUG
	int err = figure.Error();
	sz = figure.size(alcsz, copy);	//change size
	assert(sz >= minArraySize);
	assert(sz <= MaxArraySize());
	err |= figure.Error();
	if(err != figure.NORMAL) SetError(FATAL, "valloc : NCBlock", err);
#else
	sz = figure.size(alcsz, copy);
#endif
	if(copy < 0)   sign = UNDECIDED;	//does not initialize
	else if(!copy) sign = ZERO;

	return sz;
}
