/*  sxfbexpx.cpp  by K.Tsuru  */
// function ID 5205  BRADIX(reference)
/*****************
SDecimal class
exp(x) by series
******************/
#ifndef SN_H
#include "sn.h"
#endif
static const char* func = "BexpSeries";
SDecimal BexpSeries(const SDouble& x){
	int e = x.NetRdxExp();
	int xsgn;
	if( (xsgn = x.Sign(5205)) == 0) return x;
	if( e > 0){	// x > 1
		x.SetError(x.OUT_OF_RANGE, func, 5205);
	}

	SDecimal sum(1.0), xf, delta;
	xf = xf.ConvToBin(x);
	ulong mt = delta.SlOpMaxValue(), k = 2;

//	sum = 1 + x;
	if(xsgn < 0 ){
		xf.ChangeSign();	XXSub(sum, xf, sum);	// xf = |x|
	} else XXAdd(sum, xf, sum);
	delta = xf;

	while(delta.Sign()){
		XsDiv(delta*xf, k, delta);
		if((xsgn < 0) && (k & 1)) XXSub(sum, delta, sum);
		else XXAdd(sum, delta, sum);
		if( (k++) >= mt ){
			sum.SetError(sum.NOT_CONVERGE, func, -5205);
			break;
		}
	}
	return sum;
}
