/* DetThVal_ExpLog.cpp by K.Tsuru made on Aug 8, 2016*/
/*
Test program to determine the threshold value of
" const uint thFigXXX = xxxx;"
in snmath.h
Run on your platform and determine them.
For three or over functions please make a tournament selection.
*/

#include "FuncComp.h"
// "FuncComp.cpp" must be linked.

void PrepareConst(uint fig){
	Timer timer;
	double t;
	RealSize C;
	timer.Start();
	C.SetEffFig(fig);
	cerr << "Loading three constants on the memory." << endl;
	SDouble pi = Pi(), e = E(), ln10 =Log10();
	t = timer.Stop();
	cout << "Loading time = " << t << "(sec), EffFig =" << pi.EffFig() << endl;
	C.SetEffFig(0);
}
int main(){
	double mx = 8.0;
	ForStm F;
/*
Test program to determine the threshold value of
" const uint thFigExpx = 1800u;"
in snmath.h
*/
	PrepareConst(10000); // It loads three constants on the memory reading from HDD.
	PrepareConst(5000); // second call is very fast for smaller value.
	Wait();

	F.Set(100, 700, 50);	
	XFuncSpeedCompare2(ExpBS, "ExpBS", ExpDS, "ExpDS", mx, F, 25); // fig > 1500 ExpBS is faster
	XFuncSpeedCompare2(Exp, "Exp", ExpDS, "ExpDS", mx, F, 25); // fig > 1500 ExpBS is faster
	Wait();

	XFuncSpeedDependOnFig(ExpBS, "ExpBS",mx,F, 5);
	XFuncSpeedDependOnFig(ExpDS, "ExpDS",mx,F, 5);
	Wait();

/*
Test program to determine which is faster.
LogE(x) is faster than LogAGM(x)
*/
//	F.Set(200, 2000, 200);	
	XFuncSpeedCompare2(LogE, "LogE", LogAGM, "LogAGM", mx, F,5, true,0.1); // fig > 2000 LogE is faster

	Ending();
}
