/* DetThVal_TrigFunc.cpp by K.Tsuru made on Aug 8, 2016*/
/*
Test program to determine the threshold value of
" const uint thFigXXX = xxxx;"
in snmath.h
Run on your platform and determine them.
For three or over functions please make a tournament selection.
*/

#include "FuncComp.h"
// "FuncComp.cpp" must be linked.

void PrepareConst(uint fig){
	Timer timer;
	double t;
	RealSize C;
	timer.Start();
	C.SetEffFig(fig);
	cerr << "Loading three constants on the memory." << endl;
	SDouble pi = Pi(), e = E(), ln10 =Log10();
	t = timer.Stop();
	cout << "Loading time = " << t << "(sec), EffFig =" << pi.EffFig() << endl;
	C.SetEffFig(0);
}
int main(){
	double mx = 8.0;
	ForStm F;

	PrepareConst(10000); // It loads three constants on the memory reading from HDD.
	PrepareConst(5000); // second call is very fast for smaller value.
//	Wait();

	F.Set(100, 1500, 100);	
XFuncSpeedCompare2(Asin, "Asin", AsinBSNW, "AsinBSNW", 1.0, F, 5); // fig >  is faster
	XFuncSpeedCompare2(AtanA, "AtanA", AtanT, "AtanT", mx, F, 10); // fig >  is faster
//	XFuncSpeedDependOnFig(AtanA, "AtanA",mx,F, 5);
//	XFuncSpeedDependOnFig(AtanT, "AtanT",mx,F, 5);
	Wait();

/*
Test program to determine which is faster.
CosS_RN(x) is faster than CosBS(x)
*/
	F.Set(500, 5000, 500);
	XFuncSpeedCompare2(CosS_RN, "CosS_RN", CosBS, "CosBS", mx, F, 5); // CosS_RN is faster
	Wait();

	XFuncSpeedCompare2(SinS_RN, "SinS_RN", SinBS, "SinBS", mx, F, 5); // SinS_RN is faster
	Wait();

	XFuncSpeedCompare2(TanRN, "TanRN", TanBS, "TanBS", mx, F, 5); // TanRN is faster


	Ending();
}
