/*  FractRdSize.cpp  by K.Tsuru  */ 
const char* title = "<<<< Optimize \"reduseSize\" of SFraction class >>>>>";
#include "sn.h"

void SumOfInverseFact(long n, uint rs){
	SFraction r(1.0), sum = 2;
#if REDUCE_SIZE!=0
	r.SetReduceSize(rs);
#endif	
	Timer timer;
	long i;

	cerr << "Now calculating 1/0! + 1/1! + 1/2! + .... 1/" << n << "! in fraction." << endl;
	cout << " under reduceSize =" << r.ReduceSize() << endl;
#if REDUCE_SIZE!=0
	cout << "ReduceStepByStep() = " << r.ReduceStepByStep() << endl;
#endif
	timer.Start();
	SLong f(1.0);
	for(i = 2; i <= n; i++){
		f *= i;
		r.Set(1.0, f);
		sum += r;
	}
	sum.Reduce();
	double t = timer.Stop();
	r.SetFormat(r.BRACKET|r.MID_CR);
	cout << sum << endl;
	cout << "CPU time = " << t << endl;
	SDouble e = sum;
	cout << e << endl;
	Wait();
}
int main(){
	ErrorPuts(title);
	long N = 2000L;
	uint rs = 128*8;
	SumOfInverseFact(N, rs);
} // N         rs  time(sec) Knuth method=ReduceStepByStep() = true
  // 500     8     0.5         0.44
  //         64     0.51
  //        128     0.50
  //        256     0.50
  //1000      8     5.30       2.92
  //         64     5.30
  //        128     5.31
  //        256     5.31
  // 2000   128    44.25       22.64
  //        512    44.63
  //       1024    44.44

