/*  OouraPi.cpp  by K.Tsuru  */
static const char* title =
"<<<<<<< Evaluation of pi by Ooura's formula based on the AGM. >>>>>>>>";
#include "sn.h"
/*
2,097,116 digits (19 times iteration)
Ooura   4 sec(radix = 10000)... 5 times faster!
my prg 22.6 sec
my ChudnovskysPi 8.8 sec
*/
// SDouble RecSqrt2(const SDouble& x, const SDouble& initVal);
int main(){
	ErrorPuts(title);
	RealSize C;
	SDouble a, b, e, c;

	uint fig;
	double ctime;
	Timer timer;
	ErrorPut("Effective figures/4 = ");
	fig = GetInt();
	C.SetEffFig(fig, C.PROPER|C.TEMP_EXTEND);
	printf("Effective figures = %u, fftMaxArraySize =%u\n", DFIGURES*e.EffFig(),fftMaxArraySize);

	timer.Start();

	c = Sqrt(0.125);
	a = 1 + 3 * c;
	b = Sqrt(a);
	e = b - 0.625;
	b = 2 * b;
	c = e - c;
	a = a + e;
	int npow = 4, it=0;

	do {
	    npow = 2 * npow;
	    e = (a + b) / 2;
	    b = Sqrt(a * b);
	    e = e - b;
	    b = 2 * b;
	    c = c - e;
	    a = e + b;
		it++;
	} while (!e.IsHidden());	// e > SQRT_SQRT_EPSILON);
// Here 'e' is almost zero. 
//	e = e * e / 4;
	a = a + b;
//	SDouble pi = (a * a - e - e / 2) / (a * c - e) / npow;
	SDouble pi = a/(c*npow);
	ctime = timer.Stop();

	puts("e =");e.Puts();	// Wait();

	SDouble diff = pi-Pi();
	ErrorPut("difference = ");
	diff.Puts();
	printf("cpu time = %8.3f iteration = %d times\n", ctime, it);
	Ending();
}
