/* RadixConversionTest.cpp by K. Tsuru */
/*
test program for radix conversion.
speed
C.SetEffFig(64000);
----------------------------------------------
cpu time of BE() = 16.2256(sec)
cpu time of SC_ConvSDecToSDbl() = 0.190909(sec)
-1.0e-256028= 0 ?
cpu time of BS_ConvSDecToSDbl() = 0.21758(sec)
1.0e-256028= 0 ?
----------------------------------------------
nealy th same
*/
#include "sn.h"
//void bar(){ 	cout << "====================================" << endl; }
void DtoBtoDtest(uint p){
	SLong a(1), b, c;
//cout << " p = " << p << endl;
	a.MultPowRdx(p);// a = DRADIX^p = 1 0000 0000 0000 ... 0000
	a--;			// a - 1= 9999 9999 9999 ... 9999
	cout << "a= " << DRADIX << "^" << p << "-1 = " << a << endl;
	SInteger si = si.ConvToBin(a);	
	cout << "in BRADIX= " << si << endl;

	b=si.DConvToDec();			// fft
	c = a-b;
	cout << c << " =0 ?";
	Wait();
}
void SDecimal_to_SDouble() {
	RealSize C;
	Timer timer;
	C.SetEffFig(64000);
	timer.Start();
	SDecimal be = BE();
	double t = timer.Stop();
	cout << "cpu time of BE() = " << t << "(sec)" << endl;
//	be.RawPuts();
	timer.Start();
	SDouble de = SC_ConvSDecToSDbl(be), diff = de - E();
	t = timer.Stop();
	cout << "cpu time of SC_ConvSDecToSDbl() = " << t << "(sec)" << endl;
	cout << diff << "= 0 ?" << endl;
	timer.Start();
	SDouble bs = BS_ConvSDecToSDbl(be);
	diff = bs - E();
	t = timer.Stop();
	cout << "cpu time of BS_ConvSDecToSDbl() = " << t << "(sec)" << endl;
	cout << diff << "= 0 ?" << endl;
	
	C.SetEffFig(0);
}
int main(){
	SDecimal_to_SDouble();
//	DtoBtoDtest(1000);
//	Ending();
}
