// SinCosTest.cpp
#include "sn.h"

void TestAppVlog10() {
	SDouble pi = Pi() * 1.0e-15;
	long pil = CeilLog10(pi);
	SLong fc = LFact(100);
	long fcl = CeilLog10(fc);
pi.Puts();
fc.Puts();
	printf("pil = %ld, fcl = %ld\n", pil, fcl);

	Wait();
}
void TestOnAxis() {
	double fc = 0.5;
	printf("TestOnAxis() x/pi  sin(x)  cos(x) quadrant\n");
	SDouble pi = Pi(), x = fc * pi;
	TrigFuncValues tv = CosSinBS(x);
	printf("fc = %g ", fc);
	x.Puts();
	tv.sin.Put(5,20);
	printf("  ");	tv.cos.Put(5,20);
	printf("  %d\n", tv.quadrant);
SDouble y = TanBS(pi);
y.Puts();
	for(int i = 1; i<11 ; i++){
		fc = 0.5 * i;		x = pi * fc;
		printf("%3.1f   ", fc);
		tv = CosSinBS(x);
		tv.sin.Put(5,20);
		printf("  ");	tv.cos.Put(5,20);
		printf("  %d\n", tv.quadrant);
	}
}
void CalcPi(int fig) {
// Dev-C++  .exe o͐ sn32/exe ɂĂƁB
// 萔t@C pi.snc Ȃbǂݍ܂ȂB
	RealSize C;
	Timer timer;
	C.SetEffFig(fig);
	timer.Start();
	Pi();
	double tPi = timer.Stop();
	printf("Pi() CPU time = %12.4f in fig = %d\n", tPi, fig);
}
void ComapareSpeed_1(const SDouble& x) {
puts("*********** Compare Speed ****************");
while(1){
	ErrorPut("Effective figures/4 =? (<=0 quit)");
	int fig = abs(GetInt());
	if(fig <=0) return;
	Timer timer;
	RealSize C;
CalcPi(fig);
	C.SetEffFig(fig);
SDouble X = x * Sqrt(2.0);
	X.SetFormat(10,21);
	cout << "In ComapareSpeed() : X = " << X << " (top 20 digits)" << endl;

	timer.Start();
	TrigFuncValues tv = CosSinBS(X);
	double tBS = timer.Stop();
	cout << "sin(x) = " << tv.sin << endl;
	cout << "cos(x) = " << tv.cos << endl;
	cout << "CosSinBS method : upto " << tv.sin.UpToTerm() << " terms, CPU time = " << tBS << endl;
	timer.Start();
	tv = CosSinBS(X, true);
	tBS = timer.Stop();
	cout << "tan(X) =" << tv.tan << endl;
	cout<< "CosSinBS(X) CPU time = " << tBS <<endl;

	timer.Start();
	SDouble s, c, t, diff;
	s = SinS_RN(X); c =CosS_RN(X);
//	s = SinBS(X); c =CosBS(X);
	double tSC = timer.Stop();
	diff = (tv.sin - s) / s;
	printf("SinS_RN(X) & CosS_RN(X): CPU time = %12.4f\n", tSC);
	puts("( SinBS(X) - SinS_RN(X) ) / SinS_RN(x) =");
 	diff.Put(5, 20);	puts("<-- 0 ?\n");

	timer.Start();
	t = TanRN(X);
	tSC = timer.Stop();
	diff = (tv.tan - t) / t;
	printf("TanRN(x) CPU time = %12.4f\n", tSC);
	puts("( TanBS(X) - TanRN(X) ) / TanRN(x) =");
 	diff.Put(5, 20);	puts("<-- 0 ?\n");
	Wait();
	}
}


void ComapareSpeed_2(const SDouble& x) {
puts("*********** Compare Speed ****************");
while(1){
	ErrorPut("Effective figures/4 =? (<=0 quit)");
	int fig = abs(GetInt());
	if(fig <=0) return;
	Timer timer;
	RealSize C;
	CalcPi(fig);
	C.SetEffFig(fig);
	SDouble X = x * Sqrt(2.0);
	X.SetFormat(10,21);
	cout << "In ComapareSpeed() : X = " << X << " (top 20 digits)" << endl;

	SDouble cBS,sBS,c,s;
	timer.Start();
	cBS = CosBS(X);
	double tcBS = timer.Stop();
	cout<<"CosBS(X) cpu time = " << tcBS << "(sec)" << endl;
	timer.Start();
	sBS = SinBS(X);
	double tsBS = timer.Stop();
	cout<<"SinBS(X) cpu time = " << tsBS << "(sec)" << endl;

	timer.Start();
	c = Cos(X);
	double tC = timer.Stop();
	cout<<"Cos(X) cpu time = " << tC << "(sec)" << endl;
	timer.Start();
	s = Sin(X);
	double tS = timer.Stop();
	cout<<"Sin(X) cpu time = " << tS << "(sec)" << endl;
	cout << cBS - c << " <--0 ?" << endl;
	cout << sBS - s << " <--0 ?" << endl;
	Wait();
	}
}
void ValueTest(const SDouble& x) {
puts("----- ValueTest() -----");
	TrigFuncValues tv = CosSinBS(x, true);
//	tv.sin.Puts();	tv.cos.Puts();	tv.tan.Puts();

	SDouble diff;
	diff = SinS_RN(x) - tv.sin;
	printf("diffrence of sin(x) =");	diff.Puts();
	diff = CosS_RN(x) - tv.cos;
	printf("diffrence of cos(x) =");	diff.Puts();
	diff = TanRN(x) - tv.tan;
	printf("diffrence of tan(x) =");	diff.Puts();
Wait();
}
void ShowSign(int quadrant) {
	switch(quadrant) {
		case 1 : puts("sin(x) > 0, cos(x) > 0");	break;
		case 2 : puts("sin(x) > 0, cos(x) < 0");	break;
		case 3 : puts("sin(x) < 0, cos(x) < 0");	break;
		case 4 : puts("sin(x) < 0, cos(x) > 0");	break;
	}
}
void GetTriCalcMethodTest(const SDouble& x) {
puts("----- GetTriCalcMethodTest() -----");
	SDouble y, sinVal;
	int func = SIN_CALC, quadrant, sgn;
	sgn = GetTriCalcMethod(x, y, &func, &quadrant);
	y.Puts();
	printf("x / (pi/2) = %g\n", (doubleD(x) / M_PI_2));
	printf("func = %d, quadrant = %d\n", func, quadrant);
ShowSign(quadrant);
if (func == SIN_CALC) sinVal = sgn * Sin(y);
else sinVal = sgn * Cos(y);
double dx = doubleD(x), sinx = sin(dx), cosx = cos(dx);
	printf("sin(x) = %20.15f, %20.15f\n", sinx, doubleD(sinVal));
	printf("cos(x) = %20.15f\n", cosx);

Wait();
}
void Bug(){
	SDouble pi = Pi(), x = pi/4, s, n ,c, sq = Sqrt(0.5), ss;
	double eps = 1.0e-25;
	s = SinRN(x);
	c = CosRN(x); // CosSeries(x) OK, CosS_RN(x) NG CosRN(x) OK 
	ss = SinSeries(pi/4);
	cout << "SinSeries(pi/4)-Sqrt(0.5) =" << ss - s << endl; //SinSeries(pi/4) NG
	cout << "CosDiv(pi/3) =" << CosDiv(pi/3) << endl;
	cout << "SinDiv(pi/6) =" << SinDiv(pi/6) << endl;
	cout << "sinTaylorSeries(M_PI/6, eps) - 0.5 =" << (sinTaylorSeries(M_PI/6, eps) -0.5)<< endl;
	cout << "sinTaylorSeries(M_PI/6, eps) - 0.5 =" << (sinTaylorSeries(M_PI/6, eps) -0.5)<< endl;
	cout << "cosTaylorSeries(pi/6, 1.0e-240) - Sqrt(3.0)/2 =" << (cosTaylorSeries(pi/6, SDouble(1.0e-240)) -Sqrt(3.0)/2)<< endl;
	cout << "SinRN(pi/4) - Sqrt(0.5) =" << s-sq << endl; // SinRN(x) NG
	cout << "CosRN(pi/4) - Sqrt(0.5) =" << c-sq << endl;
	c = CosS_RN(x);
	cout << "CosS_RN(pi/4) - Sqrt(0.5) =" <<c-sq << endl;
	Wait();
}


int main() {
/*
CalcPi(10000);
SDouble	y = Pi() / 4, z;
z = Cos(y);
cout <<" Cos(y) = " << z <<endl;
Wait();
*/
Bug();
	SDouble	x = Pi() * Drand();
ValueTest(x);
TestOnAxis();
TestAppVlog10();
	GetTriCalcMethodTest(x);
	ComapareSpeed_2(x);
	ComapareSpeed_1(x);
	Ending();
}
